#include <avr/io.h>
#include <avr/interrupt.h>
#include "pc6031.h"
#include "spi.h"

FUSES = {0xDE, 0xD9, 0xFD};	/* Low, High, Extended */


int main(void)
{
	DDRA  = 0b11111111;		/* PIOo(port-B) to P6 */
	PORTA = 0b00000000;

	DDRB  = 0b10110011;		/* SCK, MISO, MOSI, SD_CS, SD_CD, SD_WP, LED_R, LED_G */
	PORTB = 0b11111100;		/* vAbv */

	DDRC  = 0b00000000;		/* PIO(port-A) from P6 */
	PORTC = 0b11111111;		/* vAbv */

	DDRD  = 0b11110000;		/* PIOo/(port-C) from P6 */
	PORTD = 0b00001111;		/* vAbv */

	TCCR1A = 0b00000000;
	TCCR1B = 0b00001000;

	TCCR2A = 0b00000000;
	TCCR2B = 0b00000111;	/* TIMER2 1/1024 */
	TIMSK2 = 0b00000001;	/* TIMER2ꊄ荞݋ */

	sei();

	init_spi();

	PC6031_main();

	return(0);
}

