#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "pc6031.h"
#include "eeprom.h"
#include "diskio.h"

BYTE IS_SD_EJECT_C(void);			/* SDJ[hꂽH */
void TIMER_START(void);				/* 5b^C}X^[g */

void P6PIO_sendw(BYTE, BYTE);		/* 1/2oCgf[^M */
void P6PIO_receivew(BYTE*, BYTE*);	/* 1/2oCgf[^M */
void P6PIO_sendq_pre(void);							/* 4oCgf[^MpO */
void P6PIO_sendq(BYTE, BYTE, BYTE, BYTE);			/* 4oCgf[^M */
void P6PIO_recieveq_pre(void);						/* 4oCgf[^MpO */
void P6PIO_receiveq(BYTE*, BYTE*, BYTE*, BYTE*);	/* 4oCgf[^M */
void P6PIO_init(void);				/* PIOݒ */
FRESULT P6PIO_SDinit(BYTE);			/* SDJ[hݒ */
void Check_FlashAir(void);			/* FlashAir`FbN */
BYTE d88_filechk(BYTE);				/* D88t@C`FbN */
BYTE is_file_wp(BYTE);				/* I𒆂̃t@CCgveNgH */
void file_select(void);				/* t@CZN^ */
DWORD calc_offset(BYTE, DWORD, BYTE, DWORD);	/* gbNAZN^ԍAt@C̈ʒuZo */


#define	P6PIO_send(d)		P6PIO_sendw(d, 0)		/* 1oCgf[^M */
#define	P6PIO_receive(d)	P6PIO_receivew(d, 0)	/* 1oCgf[^M */

#define	IS_ATN_HIGH		(PIO_C_IN() & _BV(3))		/* MATNHH */
#define	IS_DAC_HIGH		(PIO_C_IN() & _BV(2))		/* MDACHH */
#define	IS_RFD_HIGH		(PIO_C_IN() & _BV(1))		/* MRFDHH */
#define	IS_DAV_HIGH		(PIO_C_IN() & _BV(0))		/* MDAVHH */

#define	IS_ATN_LOW		!(PIO_C_IN() & _BV(3))		/* MATNLH */
#define	IS_DAC_LOW		!(PIO_C_IN() & _BV(2))		/* MDACLH */
#define	IS_RFD_LOW		!(PIO_C_IN() & _BV(1))		/* MRFDLH */
#define	IS_DAV_LOW		!(PIO_C_IN() & _BV(0))		/* MDAVLH */

#define	ATN_HIGH()		{ APPIC_OUT |= _BV(7);PIO_C_OUT(); }	/* MATNHɂ */
#define	DAC_HIGH()		{ APPIC_OUT |= _BV(6);PIO_C_OUT(); }	/* MDACHɂ */
#define	RFD_HIGH()		{ APPIC_OUT |= _BV(5);PIO_C_OUT(); }	/* MRFDHɂ */
#define	DAV_HIGH()		{ APPIC_OUT |= _BV(4);PIO_C_OUT(); }	/* MDAVHɂ */

#define	ATN_LOW()		{ APPIC_OUT &= ~_BV(7);PIO_C_OUT(); }	/* MATNLɂ */
#define	DAC_LOW()		{ APPIC_OUT &= ~_BV(6);PIO_C_OUT(); }	/* MDACLɂ */
#define	RFD_LOW()		{ APPIC_OUT &= ~_BV(5);PIO_C_OUT(); }	/* MRFDLɂ */
#define	DAV_LOW()		{ APPIC_OUT &= ~_BV(4);PIO_C_OUT(); }	/* MDAVLɂ */

#define	PIO_A_IN()		{ DDRC = 0x00; PORTC = 0xff; }			/* |[gA͂ɂ */
#define	PIO_B_IN()		{ DDRA = 0x00; PORTA = 0xff; }			/* |[gB͂ɂ */
#define	PIO_A_OUT()		{ DDRC = 0xff; PORTC = 0x00; }			/* |[gAo͂ɂ */
#define	PIO_B_OUT()		{ DDRA = 0xff; PORTA = 0x00; }			/* |[gBo͂ɂ */

#define	SND_B(d)		{ PORTA = d; }				/* f[^𑗐M(|[gB) */
#define	RCV_A			PINC						/* f[^M(|[gA) */
#define	SND_A(d)		{ PORTC = d; }				/* f[^𑗐M(|[gAF4oCg]p) */
#define	RCV_B			PINA						/* f[^M(|[gBF4oCg]p) */

#define PIO_C_IN()		(PIND & 0x0f)				/* |[gCf[^͂ */
#define PIO_C_OUT()		{ PORTD = ( (APPIC_OUT & 0xf0) | 0x0f); }	/* |[gCɃf[^o͂ */

#define	IS_TIMER_END	!(TIM5S & 0x01)				/* 5b^C}H */
#define	IS_SD_INSERT	!(PINB & _BV(3))			/* SDJ[h}ĂH */
#define	IS_SD_EJECT		(PINB & _BV(3))				/* SDJ[hĂH */
#define	IS_SD_WP		(PINB & _BV(2)) 			/* SDJ[hCgveNgH */

#define	SD_ENABLE()		SD_OUTENB = 0x01			/* SDJ[hL */
#define	SD_DISABLE()	SD_OUTENB = 0x00			/* SDJ[h𖳌 */
#define	IS_SD_ENABLE	(SD_OUTENB & 0x01)			/* SDJ[hLH */
#define	IS_SD_DISABLE	!(SD_OUTENB & 0x01)			/* SDJ[hH */

/* Flash-Air SharedMemory ̃AhX */
#define	SharedMemoryAdd	( (DWORD)0x90000000 | ( (DWORD)0x1000 << 9) | (DWORD)0x1FF )

/* Oϐ */
BYTE	buff[512];				/* ǂݏpobt@ */
DISK_t	diskp;					/* hCu#1,#2̃p[^ */
char	initfile[9];			/* t@C */
BYTE	diskmode[DRVNUM];		/* (d88)fBXN 0x00:1D(2D) / 0x10:1DD(2DD) */
DWORD	trk_00[DRVNUM];			/* (d88)gbN#0ZN^#0̈ʒu */
BYTE	diskwritep[DRVNUM];		/* (d88)0x10ACgveNg */

BYTE	air_acc;				/* FlashAir W-02/03/04 łSharedMemoryւ̃ANZX */
BYTE	air_w023;				/* FlashAir W-02/03    łSharedMemoryւ̃ANZX */
BYTE	air_check;				/* FlashAir ̃`FbN */

FATFS	sfs[DRVNUM];
DIR		sdir;
FILINFO	sfno;

volatile BYTE	PIO_error;		/* PIO ʐMG[ */
volatile BYTE	APPIC_OUT;		/* |[gC̏o̓f[^ */
volatile BYTE	SD_OUTENB = 0;	/* SDCl[u */
volatile BYTE	TIM5S = 0;		/* 5b^C} */
volatile BYTE	TIM5SB = 0;		/* 5b^C}B */

/* SDJ[hꂽH */
BYTE IS_SD_EJECT_C(void)
{
	UINT	i;

	for (i = 0;i < 10;i ++) {	/* `^OLZ */
		if ( IS_SD_INSERT ) {
			break;
		}
		_delay_ms(10);
	}
	return ( (i == 10) ? 1 : 0);
}

/* TIMER2 over interrupt */
ISR(TIMER2_OVF_vect)
{
	if (TIM5SB >= 200) {
		TIM5SB =  0;
	} else {
		TIM5SB ++;
	}
}

/* TIMER1 compare interrupt */
ISR(TIMER1_COMPA_vect)
{
	TCNT1   =  0;
	TCCR1B  =  0b00001000;	/* JEgXgbv */
	TIMSK1 &= ~0b00000010;	/* ^C}Ar荞݋֎~ */
	TIM5S   =  0;
}

/* 5b^C}X^[g */
void TIMER_START(void)
{
	TCNT1   = 0;
	TCCR1A  = 0b00000000;
	OCR1A   = (UINT)(F_CPU >> 10) * 5;	/* 1/1024 */
	TIMSK1 |= 0b00000010;				/* ^C}Ar荞݋ */
	TCCR1B  = 0b00001101;				/* CTC/1024ŃJEgX^[g */
	TIM5S   = 1;
}

/* 2oCgf[^M */
void P6PIO_sendw(BYTE dt1, BYTE dt2)
{
	if ( PIO_error ) {
		return;
	}

	TIMER_START();
	while ( IS_RFD_LOW ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}

	SND_B(dt1);

	DAV_HIGH();

	TIMER_START();
	while ( IS_DAC_LOW ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}

	SND_B(dt2);

	DAV_LOW();

	TIMER_START();
	while ( IS_DAC_HIGH ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}
}

/* 4oCgf[^MO */
void P6PIO_sendq_pre(void)
{
	if ( PIO_error ) {
		return;
	}

	PIO_B_OUT();
	PIO_A_OUT();

	TIMER_START();
	while ( IS_RFD_LOW ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}
}

/* 4oCgf[^M */
void P6PIO_sendq(BYTE dt1, BYTE dt2, BYTE dt3, BYTE dt4)
{
	if ( PIO_error ) {
		return;
	}

	SND_B(dt1);
	SND_A(dt2);

	DAV_HIGH();

	TIMER_START();
	while ( IS_DAC_LOW ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}

	SND_B(dt3);
	SND_A(dt4);

	DAV_LOW();

	TIMER_START();
	while ( IS_DAC_HIGH ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}
}

/* 2oCgf[^M */
void P6PIO_receivew(BYTE *dt1, BYTE *dt2)
{
	if ( PIO_error ) {
		return;
	}

	RFD_HIGH();

	TIMER_START();
	while ( IS_DAV_LOW ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}

	RFD_LOW();

	*dt1 = RCV_A;

	DAC_HIGH();

	TIMER_START();
	while ( IS_DAV_HIGH ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}

	if (dt2) {
		*dt2 = RCV_A;
	}

	DAC_LOW();
}

/* 4oCgf[^M */
void P6PIO_receiveq_pre(void)
{
	if ( PIO_error ) {
		return;
	}

	PIO_B_IN();
	PIO_A_IN();

	RFD_HIGH();
}

/* 4oCgf[^M */
void P6PIO_receiveq(BYTE *dt1, BYTE *dt2, BYTE *dt3, BYTE *dt4)
{
	if ( PIO_error ) {
		return;
	}

	TIMER_START();
	while ( IS_DAV_LOW ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}

	RFD_LOW();

	*dt1 = RCV_A;
	*dt2 = RCV_B;

	DAC_HIGH();

	TIMER_START();
	while ( IS_DAV_HIGH ) {
		if ( IS_TIMER_END ) {
			PIO_error = 1;
			APPIC_OUT = 0x00;
			PIO_C_OUT();
			return;
		}
	}

	*dt3 = RCV_A;
	*dt4 = RCV_B;

	DAC_LOW();
}

/* PIO */
void P6PIO_init(void)
{
	PIO_B_OUT();
	PIO_A_IN();
	SND_B(0x00);
	APPIC_OUT = 0x00;
	PIO_C_OUT();
	PIO_error = 0;
}

/* SD */
FRESULT P6PIO_SDinit(BYTE drvno)
{

	BYTE	dno, dst, ded;
	WORD	fdate, ftime;
	BYTE	i;
	FRESULT	res;

	if ( IS_SD_EJECT ) {
		SD_DISABLE();
		return FR_NO_FILESYSTEM;
	}
	SD_ENABLE();

	if (drvno == 0xff) {
		LEDG_ON();
		LEDR_ON();
		_delay_ms(500);
		LEDG_OFF();
		LEDR_OFF();
		_delay_ms(10);

		air_check = 0;
		diskp.air[0] = 0;
		diskp.air[1] = 0;
	}

	if ( (res = pf_mount(&sfs[0])) ) {
		return res;
	}
	LEDG_ON();

	/* copy FATFS */
	sfs[1].fs_type    = sfs[0].fs_type;
	sfs[1].flag       = sfs[0].flag;
	sfs[1].csize      = sfs[0].csize;
	sfs[1].pad1       = sfs[0].pad1;
	sfs[1].n_rootdir  = sfs[0].n_rootdir;
	sfs[1].n_fatent   = sfs[0].n_fatent;
	sfs[1].fatbase    = sfs[0].fatbase;
	sfs[1].dirbase    = sfs[0].dirbase;
	sfs[1].database   = sfs[0].database;
	sfs[1].fptr       = sfs[0].fptr;
	sfs[1].fsize      = sfs[0].fsize;
	sfs[1].org_clust  = sfs[0].org_clust;
	sfs[1].curr_clust = sfs[0].curr_clust;
	sfs[1].dsect      = sfs[0].dsect;

	if (drvno == 0) {
		dst = 0;
		ded = 1;
	} else if (drvno == 0) {
		dst = 1;
		ded = 2;
	} else {
		dst = 0;
		ded = DRVNUM;
	}

	for (dno = dst;dno < ded;dno ++) {

		strcpy( initfile, INI_FILE);
		strncat(initfile, ".", 1);
		strncat(initfile, diskp.fext[dno], 3);

		pf_remount(&sfs[dno]);

		diskp.fbody[dno][0] = 0;
		diskp.fname[dno][0] = 0;

		if ( pf_opendir(&sdir, diskp.dname[dno]) ) {
			continue;
		}

		fdate = 0;
		ftime = 0;

		for (;;) {
			if ( pf_readdir(&sdir, &sfno) ) {
				break;
			}
			if (sfno.fname[0] == 0) {
				break;
			}
			if ( strcmp(sfno.fname, initfile) == 0 ) {
				strcpy( diskp.fname[dno], diskp.dname[dno]);
				strncat(diskp.fname[dno], "/", 1);
				strcpy( diskp.fbody[dno], initfile);
				strncat(diskp.fname[dno], diskp.fbody[dno], 13);
				break;
			}
			if ( (sfno.fattrib & AM_DIR) || (sfno.fattrib & AM_VOL) ) {
				continue;
			}
			for (i = 0;i < 13;i ++) {
				if (sfno.fname[i] == '.') {
					break;
				}
			}
			if ( strcmp(&sfno.fname[i+1], diskp.fext[dno]) == 0 ) {
				if ( (fdate < sfno.fdate) || (fdate == sfno.fdate && ftime < sfno.ftime) ) {
					fdate = sfno.fdate;
					ftime = sfno.ftime;
					strcpy( diskp.fname[dno], diskp.dname[dno]);
					strncat(diskp.fname[dno], "/", 1);
					strcpy( diskp.fbody[dno], sfno.fname);
					strncat(diskp.fname[dno], diskp.fbody[dno], 13);
				}
			}
		}

		if ( diskp.fname[dno][0] != 0 ) {

			pf_remount(&sfs[dno]);

			d88_filechk(dno);

			diskp.writep[dno] = ( IS_SD_WP ) ? 1 : is_file_wp(dno);

		}

	}

	LEDG_OFF();
	return FR_OK;
}

/* FlashAir`FbN */
void Check_FlashAir(void)
{
	BYTE	j;

	if ( diskp.air[0] ) {
		return;
	}

	if (air_check > 50) {
		return;
	}

	diskp.air[0] = 0;
	diskp.air[1] = 0;

	air_acc  = 1;
	for (j = 0;j < 2;j ++) {
		air_w023 = j;
		if ( !disk_readp(buff, SharedMemoryAdd, 0, 512) ) {
			diskp.air[0] = 1;
			diskp.air[1] = 1;
			diskp.airw023[0] = j;
			diskp.airw023[1] = j;
		}
	}
	air_acc  = 0;

	air_check ++;
	return;

}

/* D88t@C`FbN */
BYTE d88_filechk(BYTE dno)
{
	BYTE	error_det;
	UINT	buffrd;

	error_det = 0;

	if ( pf_open(diskp.fname[dno]) ) {
		error_det = 1;
	}

	if ( strcmp(diskp.fext[dno], EXT_D88) == 0 ) {
		if ( pf_lseek( 0x00000000 ) ) {
			error_det = 1;
		}
		if ( pf_read(buff , 0x24, &buffrd ) ) {
			error_det = 1;
		}
		if (buffrd != 0x24) {
			error_det = 1;
		}
		if ( error_det ) {
			diskwritep[dno] = 0x00;
			diskmode[dno]   = 0xff;
			trk_00[dno]     = 0x00000000;
		} else {
			diskwritep[dno] = buff[0x1a];
			diskmode[dno]   = buff[0x1b];
			trk_00[dno]     = ( (DWORD)buff[0x20]       );
			trk_00[dno]    += ( (DWORD)buff[0x21] <<  8 );
			trk_00[dno]    += ( (DWORD)buff[0x22] << 16 );
			trk_00[dno]    += ( (DWORD)buff[0x23] << 24 );
		}
	}

	return error_det;

}

/* t@C؂o */
char* get_fname(char *retname, char *fname)
{
	BYTE	i,k;
	char	*ret;

	ret = retname;

	for (i = 0;i < FNAMELEN;i ++) {
		if (*fname++ == '/') {
			break;
		}
	}
	for (k = 0;k < 8;k ++) {
		if (*fname == '.') {
			break;
		}
		*retname++ = *fname++;
	}
	*retname = 0;

	return ret;
}

/* I𒆂̃t@CCgveNgH */
BYTE is_file_wp(BYTE dno)
{

	FRESULT	res;

	if ( strcmp(diskp.fext[dno], EXT_D88) == 0 ) {
		if (diskwritep[dno] == 0x10) {
			return 1;
		}
	}

	pf_remount(&sfs[dno]);

	if ( pf_opendir(&sdir, diskp.dname[dno]) ) {
		return 0;
	}


	for (;;) {
		if ( (res = pf_readdir(&sdir, &sfno) ) ) {
			return 0;
		}
		if (sfno.fname[0] == 0) {
			return 0;
		}
		if ( (sfno.fattrib & AM_DIR) || (sfno.fattrib & AM_VOL) ) {
			continue;
		}
		if ( strcmp(sfno.fname, diskp.fbody[dno]) != 0) {
			continue;
		}
		return ( sfno.fattrib & AM_RDO ) ? 1 : 0;
	}

}

/* gbNAZN^ԍAt@C̈ʒuZo */
DWORD calc_offset(BYTE drvno, DWORD trkno, BYTE secno, DWORD filelen)
{
	DWORD	ofs;
	DWORD	secnodw;

	secnodw = (DWORD)(secno - 1);

	if ( strcmp(diskp.fext[drvno], EXT_P31) == 0 ) {	/* P31tH[}bg */
		if ( diskp.mode[drvno] == 0 ) {					/* hCu1D */
			trkno = ( trkno << 1 );
		}
		ofs =  ( trkno << 13 );		/* 0x2000 */
		ofs += ( secnodw << 9 );	/* 0x0200 */

		return ofs;
	}

	if ( strcmp(diskp.fext[drvno], EXT_D88) == 0 ) {	/* d88tH[}bg */

// ڍ׃`FbN͌vO̒ʂ肾Aƒx̂Ńt@CtH[}bgŒ肾Ɖ
// t@C擪
// 0x001aFveNg
// 0x001bFfBXN
// 0x0020`0x0023FgbN#0̊JnAhX
// gbN#0`#39i1Dj^#0`#79i1DDj
// ZN^#1`#16ԂɊi[Ă̂Ƃ

		if (diskmode[drvno] == 0x00) {				/* fBXNF1D (2D) */
			if ( diskp.mode[drvno] != 0 ) {			/* fBXNF1D^hCuF1DD */
				trkno = ( trkno >> 1 );
			}
		} else if (diskmode[drvno] == 0x10) {		/* fBXNF1DD (2DD) */
			if ( diskp.mode[drvno] == 0 ) {			/* fBXNF1DD^hCuF1D */
				trkno = ( trkno << 1 );
			}
		} else {
			ofs = 0xffffffff;
			return ofs;
		}

		ofs  = trk_00[drvno];
		ofs += (DWORD)( 0x00000010 );
		ofs += ( trkno   << 12 );
		ofs += ( trkno   <<  8 );		/* trkno   * 0x1100 */
		ofs += ( secnodw <<  8 );
		ofs += ( secnodw <<  4 );		/* secnodw * 0x0110 */
		return ofs;

	}

// ̃vOigbNʒuAZN^ԍƃT[`
//
//		if ( pf_lseek( 0x0000001b ) ) {
//			ofs = 0xffffffff;
//			return ofs;
//		}
//		if ( pf_read(buff , 1, &buffrd ) ) {
//			ofs = 0xffffffff;
//			return ofs;
//		}
//		if (buffrd != 1) {
//			ofs = 0xffffffff;
//			return ofs;
//		}
//
//		if (buff[0] == 0x00) {						/* fBXNF1D (2D) */
//			if ( diskp.mode[drvno] != 0 ) {			/* fBXNF1D^hCuF1DD */
//				trkno = ( trkno >> 1 );
//			}
//		} else if (buff[0] == 0x10) {				/* fBXNF1DD (2DD) */
//			if ( diskp.mode[drvno] == 0 ) {			/* fBXNF1DD^hCuF1D */
//				trkno = ( trkno << 1 );
//			}
//		} else {
//			ofs = 0xffffffff;
//			return ofs;
//		}
//
//		trkno  = ( trkno << 3 );
//		trkno += (DWORD)( 0x00000020 );
//
//		if ( pf_lseek( trkno ) ) {
//			ofs = 0xffffffff;
//			return ofs;
//		}
//		if ( pf_read(buff , 4, &buffrd ) ) {
//			ofs = 0xffffffff;
//			return ofs;
//		}
//		if (buffrd != 4) {
//			ofs = 0xffffffff;
//			return ofs;
//		}
//
//		ofs  = ( (DWORD)buff[0]       );
//		ofs += ( (DWORD)buff[1] <<  8 );
//		ofs += ( (DWORD)buff[2] << 16 );
//		ofs += ( (DWORD)buff[3] << 24 );
//
//		for (i = 0;i < 16;i ++) {
//			if ( pf_lseek( ofs ) ) {
//				ofs = 0xffffffff;
//				return ofs;
//			}
//			if ( pf_read(buff, 3, &buffrd ) ) {
//				ofs = 0xffffffff;
//				return ofs;
//			}
//			if (buffrd != 3) {
//				ofs = 0xffffffff;
//				return ofs;
//			}
//			if (buff[2] == secno) {
//				ofs += (DWORD)( 0x00000010 );
//				return ofs;
//			}
//			ofs += (DWORD)( 0x00000110 );
//		}
//
//		ofs = 0xffffffff;
//		return ofs;
//	}

	if ( strcmp(diskp.fext[drvno], EXT_DSK) == 0 ) {		/* dsktH[}bg */

		if (filelen == 0x00028000) {			/* fBXNF1D */
			if ( diskp.mode[drvno] != 0 ) {		/* fBXNF1D^hCuF1DD */
				trkno = ( trkno >> 1 );
			}
		} else {
			if ( diskp.mode[drvno] == 0 ) {		/* fBXNF1DD^hCuF1D */
				trkno = ( trkno << 1 );
			}
		}
		ofs =  ( trkno << 12 );		/* 0x1000 */
		ofs += ( secnodw << 8 );	/* 0x0100 */

		return ofs;

	}

	ofs =  ( trkno << 12 );		/* 0x1000 */
	ofs += ( secnodw << 8 );	/* 0x0100 */

	return ofs;
}

void PC6031_main(void)
{

	BYTE	secnum;				/* ZN^ */
	BYTE	drvno;				/* hCuԍ */
	BYTE	trkno;				/* gbNԍ */
	BYTE	trknoh;				/* gbNԍʁigj */
	BYTE	secno;				/* ZN^ԍ */
	BYTE	bufenb;				/* [hf[^ */
	BYTE	verenb;				/* o[Wf[^ǂݏo */
	BYTE	cmd;				/* MR}h */

	BYTE	error_det;			/* G[o */

	BYTE	maddh, maddl;		/* AhXwp */
	BYTE	msizeh, msizel;		/* AhXwp */
	WORD	madd, msize;
	BYTE	dt1, wdt[4];		/* f[^Mp */
	char	tmpname[9];			/* t@Cp */
	UINT	buffrd, buffwr;

	BYTE	rstdisable;			/* Zbg */

	BYTE	xdt,seccnt, rd_f;
	BYTE	tim_b;
	UINT	i,j,k, bufpt;
	DWORD	trknoext;
	DWORD	ofs, ofs_f;

	FRESULT	res;

	air_acc  = 0;
	air_w023 = 0;
	tim_b = 0;
	rstdisable = 0;

	strcpy(diskp.dname[0], D1DIR);
	strcpy(diskp.dname[1], D2DIR);

	bufenb  = 0;
	verenb  = 0;
	secnum  = 0;
	drvno   = 0;
	trkno   = 0;
	trknoh  = 0;
	secno   = 1;
	error_det = 0;
	diskp.mode[0] = 0;
	diskp.mode[1] = 0;

	strcpy(diskp.fext[0], EXT_P31);
	strcpy(diskp.fext[1], EXT_P31);

	SD_DISABLE();

	while ( IS_P6_RESET ) {
	}

	P6PIO_init();

	for (;;) {

		do {


			while ( IS_P6_RESET && ( !rstdisable ) ) {
				LEDG_ON();
				LEDR_ON();
				SD_DISABLE();
				strcpy(diskp.fext[0], EXT_P31);
				strcpy(diskp.fext[1], EXT_P31);
				LEDG_OFF();
				LEDR_OFF();
				continue;
			}


			if ( IS_SD_ENABLE && ( !IS_SD_EJECT_C() ) ) {

				if (tim_b != TIM5SB) {
					tim_b = TIM5SB;
					if (TIM5SB == 0) {
						Check_FlashAir();
						if ( diskp.air[0] ) {
							LEDG_ON();
							LEDR_ON();
							_delay_ms(10);
							LEDG_OFF();
							LEDR_OFF();
						}
					}

					if ( diskp.air[0] ) {
						air_w023  = diskp.airw023[0];

						air_acc  = 1;
						if ( ! disk_readp(buff, SharedMemoryAdd, 0, 512) ) {
							air_acc  = 0;

							switch ( buff[0] ) {

								case 0x00:		/* f[^Ȃ */
									break;

								case 'T':		/* Flash->Appւ̑M̂ */
									break;

								case 'U':		/* C[Wt@C̃A}Eg */
/*   0FR}h   "U"      */
/*   1FhCuԍ "0"`"3" */
									for (j = 0;j < 11;j ++) {
										buff[2+j] = ' ';
									}

								case 'D':		/* C[Wt@CύX */
/*   0FR}h   "D"      */
/*   1FhCuԍ "0"`"3" */
/* 2-9Ft@Ci󔒂"z"j */
									drvno = buff[1] - '0';

									for (j = 0;j < 8;j ++) {
										tmpname[j] = buff[2+j];
										if (tmpname[j] == 'z') {
											tmpname[j] = 0;
										}
									}
									tmpname[j] = 0;

									LEDG_ON();

									strcpy( diskp.fbody[drvno], tmpname);
									strncat(diskp.fbody[drvno], ".", 1);

									for (j = 0;j < 3;j ++) {
										tmpname[j] = buff[10+j];
										if (tmpname[j] == 'z') {
											tmpname[j] = 0;
										}
									}
									tmpname[j] = 0;
									if (buff[0] == 'D') {
										strcpy(diskp.fext[drvno], tmpname);
									}

									strncat(diskp.fbody[drvno], diskp.fext[drvno], 3);

									strcpy( diskp.fname[drvno], diskp.dname[drvno]);
									strncat(diskp.fname[drvno], "/", 1);
									strncat(diskp.fname[drvno], diskp.fbody[drvno], 13);


									pf_remount(&sfs[drvno]);

									d88_filechk(drvno);
									diskp.writep[drvno] = ( IS_SD_WP ) ? 1 : is_file_wp(drvno);

									LEDG_OFF();

									break;

								case 'P':		/* Zbg̃t@C^gq */

									rstdisable = ( (buff[1] > '0') ? 1 : 0);
									break;

								default:
									break;
							}

						}
						air_acc  = 0;

						buff[ 0] = 'T';
						buff[ 1] = 1;
						buff[ 2] = 0;
						buff[ 3] = 0;
						buff[ 4] = 0;
						buff[ 5] = 0;
						buff[ 6] = rstdisable;
						buff[ 7] = 0;

						for (i = 0;i < 2;i ++) {
							for (j = 0;j < 12;j ++) {
								if (diskp.fbody[i][j] == 0) {
									break;
								}
								buff[8+j+i*12] = diskp.fbody[i][j];
							}
							for (; j < 12;j ++) {
								buff[8+j+i*12] = ' ';
							}
						}

						air_acc  = 1;
						disk_writep(0,    SharedMemoryAdd);
						disk_writep(buff, SharedMemoryAdd);
						disk_writep(0,    0              );
						air_acc = 0;
					}

				}
				continue;
			}

			if ( IS_SD_ENABLE && IS_SD_EJECT_C() ) {
				SD_DISABLE();
				for (drvno = 0;drvno < DRVNUM;drvno ++) {
					diskp.fname[drvno][0] = 0;
				}
			}

			if ( IS_SD_DISABLE ) {
				P6PIO_SDinit(0xff);
			}

		} while ( IS_ATN_LOW );		/* R}h҂i^CAEgoȂj */

		PIO_error = 0;

		P6PIO_receive(&cmd);
		if ( PIO_error ) {
			continue;
		}

		switch (cmd) {

			case 0x00:		/* initialize */
				PIO_error = 0;
				error_det = 0;
				bufenb = 0;
				verenb = 0;
				break;

			case 0x01:		/* write data */
			case 0x11:		/* high speed write data */
			case 0x83:		/* expand write data */
			case 0x84:		/* expand high speed write data */
			case 0x86:		/* double high speed write data */
			case 0x87:		/* expand double high speed write data */

				trknoh = 0;
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&secnum);
				P6PIO_receive(&drvno);
				if (cmd == 0x83 || cmd == 0x84 || cmd == 0x87) {
					P6PIO_receive(&trknoh);
				}
				P6PIO_receive(&trkno);
				P6PIO_receive(&secno);
				if (drvno >= DRVNUM) {
//					if (drvno != EEPROM_EXT && drvno != EEPROM_AVR) {
					if (drvno != EEPROM_AVR) {
						error_det = 1;
					}
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					drvno = 0;
				}

//				if (drvno == EEPROM_EXT || drvno == EEPROM_AVR) {	/* Ot/EEPROM */
				if (drvno == EEPROM_AVR) {		/* EEPROM */
					for (k = trkno;k < trkno+secnum;k ++) {

						if (cmd == 0x01 || cmd == 0x83) {
							for (j = 0;j < 256;j ++) {
								P6PIO_receive(&buff[j]);
							}
						} else if (cmd == 0x11 || cmd == 0x84) {
							for (j = 0;j < 256;j += 2) {
								P6PIO_receivew(&buff[j], &buff[j+1]);
							}
						}

						if ( PIO_error || error_det ) {
							PIO_error = 0;
							error_det = 1;
						}
						if ( !error_det ) {
							for (j = 0;j < 256;j ++) {
//								if (drvno == EEPROM_EXT) {
//									EEPROM_EXT_w( k*256+j, buff[j] );
//								} else if (drvno == EEPROM_AVR) {
								if (drvno == EEPROM_AVR) {
									EEPROM_AVR_w( k*256+j, buff[j] );
								}
							}
						}
					}
					break;
				}


				LEDR_ON();
				pf_remount(&sfs[drvno]);
				pf_open(diskp.fname[drvno]);

				trknoext = (DWORD)(trknoh*256 + trkno);

				for (seccnt = secno;seccnt < secno+secnum;seccnt ++) {

					ofs = calc_offset(drvno, trknoext, seccnt, sfs[drvno].fsize);
					if (ofs == 0xffffffff) {
						error_det = 1;
					}
					if (seccnt < 1 || seccnt > 16) {
						error_det = 1;
					}
					if (sfs[drvno].fsize < ofs) {
						error_det = 1;
					}
					if ( diskp.writep[drvno] ) {
						error_det = 1;
					}

					rd_f  = 1;
					ofs_f =       (ofs & 0xfffffe00);	/* SD̃ZN^TCY=512oCgɃAC */
					bufpt = (UINT)(ofs & 0x000001ff);	/* AC̈ʒu */

					if (cmd == 0x86 || cmd == 0x87) {
						P6PIO_receiveq_pre();
					}

					for (j = 0;j < 256;j += 4) {

						if (cmd == 0x01 || cmd == 0x83) {
							P6PIO_receive(&wdt[0]);
							P6PIO_receive(&wdt[1]);
							P6PIO_receive(&wdt[2]);
							P6PIO_receive(&wdt[3]);
						} else if (cmd == 0x11 || cmd == 0x84) {
							P6PIO_receivew(&wdt[0], &wdt[1]);
							P6PIO_receivew(&wdt[2], &wdt[3]);
						} else if (cmd == 0x86 || cmd == 0x87) {
							P6PIO_receiveq(&wdt[0], &wdt[1], &wdt[2], &wdt[3]);
						}

						if ( PIO_error || error_det ) {
							error_det = 1;
						}

						for (k = 0;k < 4;k ++) {

	/* SD̂PZN^ǂݍ */
							if ( rd_f ) {
								if ( pf_lseek(ofs_f) ) {
									error_det = 1;
								}
								if ( pf_read(buff, 512, &buffrd) ) {
									error_det = 1;
								}
											/* t@Cł́Abuffrd512̎ */
								rd_f = 0;
							}

							if ( bufpt >= buffrd ) {
								error_det = 1;
							}
							if ( ! error_det ) {
								buff[bufpt] = wdt[k];
								bufpt ++;
								if (bufpt == 512) {

	/* SD̃ZN^̐؂ڂȂ̂ŁASD̂PZN^ */
									if ( pf_lseek(ofs_f) ) {
										error_det = 1;
									}
									if ( pf_write(buff, 512, &buffwr) ) {
										error_det = 1;
									}
									if (buffwr != 512) {
										error_det = 1;
									}
									if ( pf_write(0, 0, &buffwr) ) {
										error_det = 1;
									}

									rd_f  = 1;
									ofs_f += (DWORD)( 0x00000200 );
									bufpt = 0;

								}
							}
						}

					}
					if (cmd == 0x86 || cmd == 0x87) {
						P6PIO_init();
					}

	/* SD̂PZN^ */
					if ( ! error_det ) {
						if ( ! rd_f ) {
							if ( pf_lseek(ofs_f) ) {
								error_det = 1;
							}
							if ( pf_write(buff, 512, &buffwr) ) {
								error_det = 1;
							}
							if (buffwr != buffrd) {
								error_det = 1;
							}
							if ( pf_write(0, 0, &buffwr) ) {
								error_det = 1;
							}
						}
					}

					if ( PIO_error ) {
						PIO_error = 0;
						error_det = 1;
					}
				}

				LEDR_OFF();

				break;

			case 0x02:		/* read data */
			case 0x85:		/* expand read data */
				trknoh = 0;
				bufenb = 0;
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&secnum);
				P6PIO_receive(&drvno);
				if (cmd == 0x85) {
					P6PIO_receive(&trknoh);
				}
				P6PIO_receive(&trkno);
				P6PIO_receive(&secno);
				if (drvno >= DRVNUM) {
//					if (drvno != EEPROM_EXT && drvno != EEPROM_AVR) {
					if (drvno != EEPROM_AVR) {
						error_det = 1;
					}
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}
				if (drvno < DRVNUM) {
					if ( diskp.fname[drvno][0] == 0 ) {
						error_det = 1;
						break;
					}
				}
				bufenb = 1;
				break;

			case 0x03:		/* send data */
			case 0x12:		/* high speed send data */
			case 0x88:		/* double high speed send data */

				error_det = 0;
				if (bufenb == 0) {
					error_det = 1;
				}

				if ( error_det ) {
					break;
				}
				bufenb = 0;

//				if (drvno == EEPROM_EXT || drvno == EEPROM_AVR) {	/* Ot/EEPROM */
				if (drvno == EEPROM_AVR) {		/* EEPROM */
					for (k = trkno;k < trkno+secnum;k ++) {
						for (j = 0;j < 256;j ++) {
//							if (drvno == EEPROM_EXT) {
//								buff[j] = EEPROM_EXT_r( k*256+j );
//							} else if (drvno == EEPROM_AVR) {
							if (drvno == EEPROM_AVR) {
								buff[j] = EEPROM_AVR_r( k*256+j );
							}
						}

						if (cmd == 0x03) {
							for (j = 0;j < 256;j ++) {
								P6PIO_send(buff[j]);
							}
						} else if (cmd == 0x12) {
							for (j = 0;j < 256;j += 2) {
								P6PIO_sendw(buff[j], buff[j+1]);
							}
						}

					}
					if ( PIO_error ) {
						PIO_error = 0;
						error_det = 1;
					}
					break;
				}


				LEDG_ON();
				pf_remount(&sfs[drvno]);
				pf_open(diskp.fname[drvno]);

				trknoext = (DWORD)(trknoh*256 + trkno);

				for (seccnt = secno;seccnt < secno+secnum;seccnt ++) {

					ofs = calc_offset(drvno, trknoext, seccnt, sfs[drvno].fsize);
					if (ofs == 0xffffffff) {
						error_det = 1;
					}
					if (seccnt < 1 || seccnt > 16) {
						error_det = 1;
					}

					if (sfs[drvno].fsize < ofs) {
						error_det = 1;
					}
					if ( pf_lseek(ofs) ) {
						error_det = 1;
					}
					if ( pf_read(buff, 256, &buffrd) ) {
						error_det = 1;
					}
					if (buffrd != 256) {
						error_det = 1;
					}

					if (cmd == 0x03) {
						for (j = 0;j < 256;j ++) {
							P6PIO_send(buff[j]);
						}
					} else if (cmd == 0x12) {
						for (j = 0;j < 256;j += 2) {
							P6PIO_sendw(buff[j], buff[j+1]);
						}
					} else if (cmd == 0x88) {
						P6PIO_sendq_pre();
						for (j = 0;j < 256;j += 4) {
							P6PIO_sendq(buff[j], buff[j+1], buff[j+2], buff[j+3]);
						}
						P6PIO_init();
					}
				}
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}

				LEDG_OFF();

				break;

			case 0x05:		/* format */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				if (drvno >= DRVNUM) {
					error_det = 1;
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}

				if        ( strcmp(diskp.fext[drvno], EXT_P31) == 0 ) {	/* P31tH[}bg */
					;
				} else if ( strcmp(diskp.fext[drvno], EXT_D88) == 0 ) {	/* d88tH[}bg */
					;
				} else if ( strcmp(diskp.fext[drvno], EXT_DSK) == 0 ) {	/* dsktH[}bg */
					;
				} else {
					error_det = 1;
					break;
				}

				LEDR_ON();
				pf_remount(&sfs[drvno]);
				pf_open(diskp.fname[drvno]);

				i = ( ( diskp.mode[drvno] ) ? 80 : 40);
				for (trkno = 0;trkno < i;trkno ++) {

					trknoext = (DWORD)( trkno );

					for (seccnt = 1;seccnt < 1+16;seccnt ++) {

						ofs = calc_offset(drvno, trknoext, seccnt, sfs[drvno].fsize);
						if (ofs == 0xffffffff) {
							error_det = 1;
						}
						if (seccnt < 1 || seccnt > 16) {
							error_det = 1;
						}
						if (sfs[drvno].fsize < ofs) {
							error_det = 1;
						}
						if ( diskp.writep[drvno] ) {
							error_det = 1;
						}
						if ( error_det ) {
							break;
						}

						rd_f  = 1;
						ofs_f =       (ofs & 0xfffffe00);	/* SD̃ZN^TCY=512oCgɃAC */
						bufpt = (UINT)(ofs & 0x000001ff);	/* AC̈ʒu */

						for (j = 0;j < 256;j ++) {

	/* SD̂PZN^ǂݍ */
							if ( rd_f ) {
								if ( pf_lseek(ofs_f) ) {
									error_det = 1;
								}
								if ( pf_read(buff, 512, &buffrd) ) {
									error_det = 1;
								}
											/* t@Cł́Abuffrd512̎ */
								rd_f = 0;
							}

							if ( bufpt >= buffrd ) {
								error_det = 1;
							}
							if ( error_det ) {
								break;
							}

							buff[bufpt] = 0xff;
							bufpt ++;
							if (bufpt == 512) {

	/* SD̃ZN^̐؂ڂȂ̂ŁASD̂PZN^ */
								if ( pf_lseek(ofs_f) ) {
									error_det = 1;
								}
								if ( pf_write(buff, 512, &buffwr) ) {
									error_det = 1;
								}
								if (buffwr != 512) {
									error_det = 1;
								}
								if ( pf_write(0, 0, &buffwr) ) {
									error_det = 1;
								}

								rd_f  = 1;
								ofs_f += (DWORD)( 0x00000200 );
								bufpt = 0;

							}
							if ( error_det ) {
								break;
							}
						}

						if ( error_det ) {
							break;
						}

	/* SD̂PZN^ */
						if ( ! rd_f ) {
							if ( pf_lseek(ofs_f) ) {
								error_det = 1;
							}
							if ( pf_write(buff, 512, &buffwr) ) {
								error_det = 1;
							}
							if (buffwr != buffrd) {
								error_det = 1;
							}
							if ( pf_write(0, 0, &buffwr) ) {
								error_det = 1;
							}
						}

					}
					if ( error_det ) {
						break;
					}
				}

				LEDR_OFF();

				break;

			case 0x06:		/* send result status */
				PIO_error = 0;
				P6PIO_send(0x80 + 0x40*bufenb + error_det);
				error_det = 0;
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0x07:		/* send drive status */
				PIO_error = 0;
				error_det = 0;
				P6PIO_send(0x3f);		/* hCu=2iŒj */
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0x09:		/* send memory */
			case 0x0b:		/* send memory 2 */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&maddh);
				P6PIO_receive(&maddl);
				P6PIO_receive(&msizeh);
				P6PIO_receive(&msizel);
				madd  =  maddh*0x0100 + maddl;
				msize = msizeh*0x0100 + msizel;
				if (cmd == 0x09) {
					msize = msize - madd + 1;
				}
				for (i = 0;i < msize;i ++) {
					if ( madd+i == 0x075f) {
						dt1 = 0x77;
					} else if ( madd+i == 0x07ef) {
						dt1 = 0xef;
					} else {
						dt1 = 0xff;
					}
					P6PIO_send(dt1);
				}
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0x14:		/* send device status */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				if (drvno >= DRVNUM) {
					error_det = 1;
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}

				dt1  = (drvno & 0x03);								/* US1-0 */
				dt1 += ( ( IS_SD_DISABLE ) ? 0x00 : 0x08);			/* fBXNL莞Abit3=1 */
				dt1 += ( ( diskp.writep[drvno] ) ? 0x40 : 0x00);	/* write protectAbit6=1 */

				P6PIO_send( dt1 );
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0x17:		/* set surface mode */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&dt1);
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}

				if ( error_det ) {
					break;
				}
				diskp.mode[0] = ( (dt1 & 0x01) ? 1 : 0);
				diskp.mode[1] = ( (dt1 & 0x02) ? 1 : 0);
				break;

			case 0x18:		/* send surface mode */
				PIO_error = 0;
				error_det = 0;
				P6PIO_send(diskp.mode[0] + diskp.mode[1]*2);
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0x82:		/* report disk image length */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				if (drvno >= DRVNUM) {
					error_det = 1;
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}
				pf_remount(&sfs[drvno]);
				P6PIO_send( (sfs[drvno].fsize & 0xff000000) >> 24 );
				P6PIO_send( (sfs[drvno].fsize & 0x00ff0000) >> 16 );
				P6PIO_send( (sfs[drvno].fsize & 0x0000ff00) >>  8 );
				P6PIO_send( (sfs[drvno].fsize & 0x000000ff) );
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0xe0:		/* receive EEPROM memory */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				P6PIO_receive(&maddh);
				P6PIO_receive(&maddl);
				P6PIO_receive(&msizeh);
				P6PIO_receive(&msizel);
				madd  =  maddh*0x0100 + maddl;
				msize = msizeh*0x0100 + msizel;
//				if (drvno != EEPROM_EXT && drvno != EEPROM_AVR) {
				if (drvno != EEPROM_AVR) {
					error_det = 1;
				}

				for (i = 0;i < msize;i ++) {
					P6PIO_receive(&xdt);
					if ( error_det ) {
						continue;
//					} else if (drvno == EEPROM_EXT) {
//						EEPROM_EXT_w( madd+i, xdt );
					} else if (drvno == EEPROM_AVR) {
						EEPROM_AVR_w( madd+i, xdt );
					}
				}
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0xe1:		/* send EEPROM memory */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				P6PIO_receive(&maddh);
				P6PIO_receive(&maddl);
				P6PIO_receive(&msizeh);
				P6PIO_receive(&msizel);
				madd  =  maddh*0x0100 + maddl;
				msize = msizeh*0x0100 + msizel;
//				if (drvno != EEPROM_EXT && drvno != EEPROM_AVR) {
				if (drvno != EEPROM_AVR) {
					error_det = 1;
				}

				for (i = 0;i < msize;i ++) {
					if ( error_det ) {
						xdt = 0xff;
//					} else if (drvno == EEPROM_EXT) {
//						xdt = EEPROM_EXT_r( madd+i );
					} else if (drvno == EEPROM_AVR) {
						xdt = EEPROM_AVR_r( madd+i );
					}
					P6PIO_send(xdt);
				}
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0xf0:		/* read version number */
				verenb = 1;
				break;

			case 0xf1:		/* send version number */
				PIO_error = 0;
				error_det = 0;

				if (verenb == 0) {
					error_det = 1;
				}

				if ( error_det ) {
					break;
				}
				verenb = 0;

				strncat(tmpname, MODEL_NO, 2);

				for (i = 0;i < 5;i ++) {
					P6PIO_send(tmpname[i]);
				}

				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0xf2:		/* set file extention */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				if (drvno >= DRVNUM) {
					error_det = 1;
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}

				for (i = 0;i < 3;i ++) {
					P6PIO_receive(&dt1);
					tmpname[i] = dt1;
				}
				tmpname[i] = 0;

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}
				strcpy(diskp.fext[drvno], tmpname);
				P6PIO_SDinit(drvno);
				break;

			case 0xf3:		/* send file extention */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				if (drvno >= DRVNUM) {
					error_det = 1;
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}

				for (i = 0;i < 3;i ++) {
					P6PIO_send(diskp.fext[drvno][i]);
				}

				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0xfc:		/* send image file */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				if (drvno >= DRVNUM) {
					error_det = 1;
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}

				for (i = 0;i < 8;i ++) {
					if (diskp.fbody[drvno][i] == '.') {
						break;
					}
					P6PIO_send(diskp.fbody[drvno][i]);
				}
				for (;i < 8;i ++) {
					P6PIO_send(' ');
				}

				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}
				break;

			case 0xfd:		/* get image file */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				if (drvno >= DRVNUM) {
					error_det = 1;
				}

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}

				LEDG_ON();

				pf_remount(&sfs[drvno]);
				if ( pf_opendir(&sdir, diskp.dname[drvno]) ) {
					error_det = 1;
				}
				while ( !error_det ) {
					if ( (res = pf_readdir(&sdir, &sfno) ) ) {
						error_det = 1;
						break;
					}
					if (sfno.fname[0] == 0) {
						break;
					}
					if ( (sfno.fattrib & AM_DIR) || (sfno.fattrib & AM_VOL) ) {
						continue;
					}
					for (i = 0;i < 13;i ++) {
						if (sfno.fname[i] == '.') {
							break;
						}
					}
					if ( strcmp(&sfno.fname[i+1], diskp.fext[drvno]) == 0 ) {
						P6PIO_send(0x01);			/* start of data */
						for (i = 0;i < 8;i ++) {
							if (sfno.fname[i] == '.') {
								break;
							}
							P6PIO_send(sfno.fname[i]);
						}
						for (;i < 8;i ++) {
							P6PIO_send(' ');
						}

					}
				}

				P6PIO_send(0x00);		/* end of data */

				pf_remount(&sfs[drvno]);
				if ( pf_open(diskp.fname[drvno]) ) {	/* I[vȂ */
					error_det = 1;
				}
				if ( PIO_error ) {
					PIO_error = 0;
					error_det = 1;
				}

				LEDG_OFF();

				break;

			case 0xfe:		/* set image file */
				PIO_error = 0;
				error_det = 0;
				P6PIO_receive(&drvno);
				if (drvno >= DRVNUM) {
					error_det = 1;
				}
				for (i = 0;i < 8;i ++) {
					P6PIO_receive(&dt1);
					if (dt1 == ' ') {
						dt1 = 0;
					}
					tmpname[i] = dt1;
				}
				tmpname[i] = 0;

				if ( PIO_error || error_det ) {
					PIO_error = 0;
					error_det = 1;
					break;
				}

				LEDG_ON();

				strcpy( diskp.fbody[drvno], tmpname);
				strncat(diskp.fbody[drvno], ".", 1);
				strncat(diskp.fbody[drvno], diskp.fext[drvno], 3);

				strcpy( diskp.fname[drvno], diskp.dname[drvno]);
				strncat(diskp.fname[drvno], "/", 1);
				strncat(diskp.fname[drvno], diskp.fbody[drvno], 13);

				pf_remount(&sfs[drvno]);

				d88_filechk(drvno);
				diskp.writep[drvno] = ( IS_SD_WP ) ? 1 : is_file_wp(drvno);

				LEDG_OFF();

				break;

			default:
				PIO_error = 0;
		//		error_det = 1;		/* R}hȂ̂ŁAG[ԂȂ */
				break;
		}
	}
}

